Subject: Re: changing the qdisc class speed rate

From: Jarek Poplawski <[email-masked]>
Date: Fri, 29 May 2009 22:34:25 +0200

Piotrek D wrote, On 05/29/2009 09:03 PM:

> This is what I have done, the  cl->rate->rate.rate refers to the __u32
> rate in htb_class -> qdisc_rate_table -> tc_ratespec .
> What else should I modify to make this work ?
> 

From include/net/sch_generic.h:

/* Length to Time (L2T) lookup in a qdisc_rate_table, to determine how
   long it will take to send a packet given its size.
 */
static inline u32 qdisc_l2t(struct qdisc_rate_table* rtab, unsigned int pktlen)
{
        int slot = pktlen + rtab->rate.cell_align + rtab->rate.overhead;
        if (slot < 0)
                slot = 0;
        slot >>= rtab->rate.cell_log;
        if (slot > 255)
                return (rtab->data[255]*(slot >> 8) + rtab->data[slot & 0xFF]);
        return rtab->data[slot];
}

This function controls rates and these rtab values matter here.

Jarek P.

> 
> 
> W dniu 28 maja 2009 07:21 użytkownik Stephen Hemminger
> <[email-masked]> napisał:
>> On Thu, 28 May 2009 07:12:33 +0200
>> Piotr Duszyński <[email-masked]> wrote:
>>
>>> Hi everyone,
>>>
>>> I am trying to change the rate parameter of HTB class by using this
>>> code from within one of my functions :
>>>
>>>    struct htb_class *cl;
>>>    cl=htb_find(number,q);
>>>
>>>    cl->rate->rate.rate = NEW_RATE_VALUE;
>>>
>>>    TC shows the correct values, but the traffic rate doesn't change a
>>> bit.
>>>    Does anyone have any idea what am I doing wrong ? Maybe there would
>>> be a faster way by sending a netlink  message ?
>>>
>>> Piotrek
>> HTB uses a rate table, so if you want the rate to change, you will need to change the
>> table as well.
>>
> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>